import Action from '@overflow/commons/redux/Action';
import { ReducersMapObject } from 'redux';
import * as _ from 'lodash';

import Host from '../../api/model/Host';
import Port from '../../api/model/Port';
import Service from '../../api/model/Service';

import * as IngActionTypes from '../action/ing';
import {
  HostState, hostDefaultState,
  PortState, portDefaultState,
  ServiceState, serviceDefaultState,
  DiscoveryIngState, DiscoveryIngDefaultState,
} from '../state/Ing';

const reducer: ReducersMapObject = {
  [IngActionTypes.RECEIVE_HOST]: (state: DiscoveryIngState = DiscoveryIngDefaultState,
                                  action: Action<Host>): DiscoveryIngState => {

    let hostList: Host[] = null;
    if(state.hostList === null || state.hostList === undefined) {
      hostList = new Array();
      hostList.push(action.payload);
    } else {
      hostList = _.clone(state.hostList);
      hostList.push(action.payload);
    }

    return {
      ...state,
      hostList: hostList,
    };
  },
  [IngActionTypes.RECEIVE_PORT]: (state: DiscoveryIngState = DiscoveryIngDefaultState,
                                  action: Action<Port>): DiscoveryIngState => {

    let hostList: Host[] = null;
    if(state.hostList === null || state.hostList === undefined) {
      hostList = new Array();
      let port: Port = action.payload;
      let host: Host = _.clone(port.host);
      host.ports = new Array();
      port.host = host;
      host.ports.push(port);
      hostList.push(port.host);

    } else {
      hostList = _.clone(state.hostList);
      let port: Port = action.payload;
      // let host: Host = _.clone(port.host);

      for(let h of hostList) {
        if(h.ip === port.host.ip) {
          port.host = h;
          if(h.ports === null || h.ports === undefined) {
            h.ports = new Array();
          }
          h.ports.push(port);
        }
      }

    }

    return {
      ...state,
      hostList: hostList,
    };
  },
  [IngActionTypes.RECEIVE_SERVICE]: (state: DiscoveryIngState = DiscoveryIngDefaultState,
                                     action: Action<Service>): DiscoveryIngState => {



    return {
      ...state,
      // service: action.payload,
    };
  },
};

export default reducer;
